
////////////////////////////////////
    async function placeQueueData(portid){
   
        if(curPage != 0) return;
      
        var cur_port = serialPorts[portid]; 
        
        
        if( !cur_port.isOpened ) return;
        if( cur_port.type != "RS485") return;
       
        var str = '<span style="color:red;">[' +  cur_port.writeQueue.length + ']</span>';
        
/*    This doesn't work in free JqGrid    
        var rowData = $("#portstable").jqGrid('getRowData', portid);
        rowData.port_stats = str; 
        $("#portstable").jqGrid('setRowData', portid, str);
*/
        
        $("td[aria-describedby='portstable_port_stats']", "table#portstable tr[id='" + portid + "']").html(str);
        
    }
////////////////////////////////////
// Manipulations with setRowData do not work in free JqGrid if cell data is html
    function placeCellData(devid, datatype, val){
    
        if(curPage != 1) return;
        
        if( (PZEMdevices[devid]['active'] == false) && (datatype != 'YY') ) return;
        
        var str = "<span style='font-weight:bold;'>" +  val + "</span>";
        var tbl_context = "table#pzemtable tr[id='" + devid + "']";
        
        switch (datatype) {
            case 'V':
                $("td[aria-describedby='pzemtable_pzem_curv']", tbl_context).html(str);
                break;
            case 'I':
                $("td[aria-describedby='pzemtable_pzem_curi']", tbl_context).html(str);
                break;
            case 'P':
                $("td[aria-describedby='pzemtable_pzem_curp']", tbl_context).html(str);
                break;
            case 'E':
                $("td[aria-describedby='pzemtable_pzem_cure']", tbl_context).html(str);
                break;
            case 'F':
                $("td[aria-describedby='pzemtable_pzem_curf']", tbl_context).html(str);
                break;
            case 'PF':
                $("td[aria-describedby='pzemtable_pzem_curpf']", tbl_context).html(str);
                break;
            case 'XX':
                 // just update packet counter
                break;
            case 'YY': // emty all
                 $("td[aria-describedby='pzemtable_pzem_curv'], td[aria-describedby='pzemtable_pzem_curi'], td[aria-describedby='pzemtable_pzem_curp'], td[aria-describedby='pzemtable_pzem_cure'], td[aria-describedby='pzemtable_pzem_curf'], td[aria-describedby='pzemtable_pzem_curpf'], td[aria-describedby='pzemtable_pzem_lastupd']", tbl_context).html("");
                break
            default:
                console.log("unknown datatype in placeCellData: " + datatype);
        }

        if( datatype != 'YY' ){
            var ldt = getLocalDateTime();
            var str ="<span>" + ldt + "</span>&nbsp;&nbsp;<span style='color:green;'>[" + PZEMdevices[devid]['pkt_cntr'] +"]</span><span style='color:red;'> [" + PZEMdevices[devid]['err_cntr'] + "]</span>";
            $("td[aria-describedby='pzemtable_pzem_lastupd']", tbl_context).html(str);
        }

    }    
    
    
//////////////////////////////////////////
    
    function getLocalMillisec(){
        var t = new Date();
        var z = t.getTimezoneOffset() * 60 * 1000;
        return t-z
    }


//////////////////////////////////////////

    function getLocalDate(){
        
        return new Date( getLocalMillisec() );
    }

//////////////////////////////////////////

    function getLocalDateTime(ms){
        var tLocal;
        
        if( ms == undefined || ms == null){
            tLocal = getLocalDate()
        }else{
            tLocal = new Date(ms);
        }
        
        
        iso = tLocal.toISOString();
        iso = iso.slice(0, 19);
        iso = iso.replace('T', ' ');
        return iso;
    }
    
//////////////////////////////////////////

    function getLocalDateTimeMsec(ms){
        var tLocal;
        
        if( ms == undefined || ms == null){
            tLocal = getLocalDate()
        }else{
            tLocal = new Date(ms);
        }
        
        
        iso = tLocal.toISOString();
        iso = iso.slice(0, 23);
        iso = iso.replace('T', ' ');
        return iso;
    }    
/////////////////////////////////////
 
    function delayms(delayInms) {
        return new Promise(resolve => {
            setTimeout(() => {
                resolve(2);
            }, delayInms);
        });
    }
//////////////////////////////////////

    async function remove_old_db_records(devid){
        var t = getLocalDate();
        //var z = t.getTimezoneOffset() * 60 * 1000;
        var x = PZEMdevices[devid]['device']['delDB']  * 60 * 60 * 1000;
        tBound = t-x;

        db.records
            .where("timestamp").below( tBound )
            .delete();
 
    }
    
//////////////////////////////////////
    
    function MODBUScrc16(buffer) {
        var crc = 0xFFFF;
        var odd;
    
        for (var i = 0; i < buffer.length; i++) {
            crc = crc ^ buffer[i];
    
            for (var j = 0; j < 8; j++) {
                odd = crc & 0x0001;
                crc = crc >> 1;
                if (odd) {
                    crc = crc ^ 0xA001;
                }
            }
        }
    
        return crc;
    };
//////////////////////////////////////////

    function destroyChart(){
        try{
            chart1.destroy();
        }catch (err) {
            console.error('Error while clearing chart data: ' + err);
        }
        
    }